<template>
  <div class="room-container">
    <ion-text class="avatar" :class="[computedItemData.avatarClass]"
      >{{ getFirstChar }}
      <img
        v-if="gettingImage"
        class="avatar-image"
        :src="gettingImage"
        @load="imageProfileLoaded"
      />
    </ion-text>
    <div class="room-info">
      <div class="info">
        <span class="name">
          {{ computedItemData.name }}
        </span>
        <div class="message-content">
          <span class="last-message"> hello </span>
          <span class="checker">
            <IonIcon
              color="primary"
              :icon="checkmarkDone"
              size="small"
              v-if="item.lastSeenData.isSeen"
            ></IonIcon>
            <IonIcon
              :icon="checkmark"
              size="small"
              v-else
              color="primary"
            ></IonIcon>
          </span>
        </div>
      </div>
      <div class="badge-time-container">
        <span class="time">
          {{ item.date.slice(0, 10) }}
        </span>
        <span
          class="badge"
          :class="{ 'badge-fa': locale == 'fa', 'badge-en': locale == 'en' }"
        >
          12
        </span>
      </div>
    </div>
  </div>
</template>
<script setup>
import { IonText, IonIcon } from '@ionic/vue';
import { checkmark, checkmarkDone } from 'ionicons/icons';

import { computed, onMounted, defineProps, defineEmits } from 'vue';
import { useContactsStore } from '@/store/contacts/contacts.js';
import { useFileManagerStore } from '@/store/fileManager/fileManager.js';
import { useI18n } from 'vue-i18n';
const { locale } = useI18n();
const contactStore = useContactsStore();
const props = defineProps({
  item: {
    type: Object,
  },
});
const getFirstChar = computed(() => {
  return computedItemData.value.name ? computedItemData.value.name[0] : '';
});
const computedItemData = computed(() => {
  if (props.item.groupData) return props.item.groupData;
  const user = contactStore.contacts.navaphoneUsers.find(
    (e) => e.contact_username == props.item.chatId,
  );
  if (user) {
    return {
      ...user,
      name: user.nickname || user.name || props.item.information.name,
    };
  }
  return {
    avatarClass: props.item?.information?.avatarClass || 'avatar-color-2',
    name: props.item.information.name,
  };
});

const gettingImage = computed(() => {
  const fileManagerStore = useFileManagerStore();
  const profile =
    fileManagerStore.blobFilePathDownloadedList[props.item.chatId];
  if (profile) {
    return profile.filePath;
  }
  return false;
});
const emit = defineEmits(['getAddionalProfileInfo']);

onMounted(() => {
  if (!props.item.groupData) emit('getAddionalProfileInfo', props.item);
});
</script>

<style scoped>
.room-container {
  width: 100%;
  height: 100px;
  display: flex;
  cursor: pointer;
}

.room-container .avatar {
  width: 60px;
  height: 60px;
  border-radius: 50%;
  display: flex;
  justify-content: center;
  align-items: center;
  font-size: 18px;
  font-weight: 700;
  color: #fff;
}

.room-container .room-info {
  width: 80%;
  margin-left: 10px;
  margin-right: 10px;
  height: 60px;
  border-bottom: 1px solid #d4d4d4;
  display: flex;
}

.room-container .room-info .info {
  width: 70%;
  height: 60px;
  display: flex;
  flex-direction: column;
}

.info .name {
  font-size: 16px;
  padding: 5px 0;
  font-weight: 600;
}

.last-message {
  font-size: 12px;
  padding: 5px 0;
  font-weight: 500;
  color: #9b9b9b;
}

.message-content {
  display: flex;
}
.checker {
  padding: 1px 4px;
}

.badge-time-container {
  width: 30%;
  display: flex;
  flex-direction: column;
  align-items: end;
}
.time {
  font-size: 10px;
  font-weight: 500;
  color: #9b9b9b;
  padding-top: 5px;
}

.badge {
  border-radius: 50%;
  background: rgb(71, 95, 226);
  color: #fff;
  font-size: 11px;
  font-weight: 600;
  margin-top: 10px;
}

.badge-fa {
  padding: 3px 6px;
}

.badge-en {
  padding: 6px 6px;
}
</style>
